#!/usr/bin/perl -w

$confGmetric = "/usr/bin/gmetric --tmax=4000 --dmax=4000";
$confSmartctl= "/usr/sbin/smartctl";
$confGanglia = "/etc/gmond.conf";

die "Ganglia is not installed"  if ! -r $confGanglia;

$ip   = "239.2.11.71";
$port = "8649";

open(IN,"$confGanglia") || die "Cannot read $confGanglia";
while (<IN>)
  {
    next if /^#/;
    $ip   = $1 if /mcast_channel +(.*)/;
    $port = $1 if /mcast_port +(.*)/;
  }
close IN;

exit 0 unless -r "/sys/block";

foreach my $dev (`/bin/ls -1 /sys/block`)
  {
    chop $dev;
    next if ! -r "/sys/block/$dev/device";

    my $smartData = `$confSmartctl -a /dev/$dev 2>&1`;

    #print $smartData;
    
    foreach my $entry (split(/\n/,$smartData))
      {
        #print "-> $entry\n";
        
        $entry =~ s/^\s*//;
        my @entry = split(/\s+/,$entry);
        
        next if (@entry != 10);
        
        my $id   = $entry[0];
        my $name = $entry[1];
        my $val  = $entry[9];
        
        next unless $id  =~ /^\d+$/;
        next unless $val =~ /^\d+$/;
        
        $id = sprintf("%3d",$id);
        
        #print scalar @entry,$entry[0],$entry[1],"  $entry\n";
        
        my $cmd = "$confGmetric -c$ip -p$port -tint32 -n\"smart $dev $id $name\" -v$val";
        #print "$cmd\n";
        system $cmd;
     }
  }

exit 0;
#end file
